diff --git a/gcc/tree-ssa-math-opts.c b/gcc/tree-ssa-math-opts.c
index e7e09f6..7d3c68f 100644
--- a/gcc/tree-ssa-math-opts.c
+++ b/gcc/tree-ssa-math-opts.c
@@ -636,26 +636,35 @@ execute_cse_reciprocals (void)
   return 0;
 }
 
-struct gimple_opt_pass pass_cse_reciprocals =
+class pass_cse_reciprocals : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "recip",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_cse_reciprocals,			/* gate */
-  execute_cse_reciprocals,		/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_ssa,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_update_ssa | TODO_verify_ssa
-    | TODO_verify_stmts                /* todo_flags_finish */
- }
-};
+public:
+  pass_cse_reciprocals(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "recip",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_update_ssa | TODO_verify_ssa | TODO_verify_stmts)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_cse_reciprocals (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_cse_reciprocals (); }
+
+}; // class pass_cse_reciprocals
+
+gimple_opt_pass *
+make_pass_cse_reciprocals (context &ctxt)
+{
+  return new pass_cse_reciprocals (ctxt);
+}
 
 /* Records an occurrence at statement USE_STMT in the vector of trees
    STMTS if it is dominated by *TOP_BB or dominates it or this basic block
@@ -1506,26 +1515,35 @@ gate_cse_sincos (void)
   return optimize;
 }
 
-struct gimple_opt_pass pass_cse_sincos =
+class pass_cse_sincos : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "sincos",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_cse_sincos,			/* gate */
-  execute_cse_sincos,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_ssa,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_update_ssa | TODO_verify_ssa
-    | TODO_verify_stmts                 /* todo_flags_finish */
- }
-};
+public:
+  pass_cse_sincos(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "sincos",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_update_ssa | TODO_verify_ssa | TODO_verify_stmts)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_cse_sincos (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_cse_sincos (); }
+
+}; // class pass_cse_sincos
+
+gimple_opt_pass *
+make_pass_cse_sincos (context &ctxt)
+{
+  return new pass_cse_sincos (ctxt);
+}
 
 /* A symbolic number is used to detect byte permutation and selection
    patterns.  Therefore the field N contains an artificial number
@@ -1979,25 +1997,35 @@ gate_optimize_bswap (void)
   return flag_expensive_optimizations && optimize;
 }
 
-struct gimple_opt_pass pass_optimize_bswap =
+class pass_optimize_bswap : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "bswap",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_optimize_bswap,                  /* gate */
-  execute_optimize_bswap,		/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_ssa,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_optimize_bswap(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "bswap",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_optimize_bswap (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_optimize_bswap (); }
+
+}; // class pass_optimize_bswap
+
+gimple_opt_pass *
+make_pass_optimize_bswap (context &ctxt)
+{
+  return new pass_optimize_bswap (ctxt);
+}
 
 /* Return true if stmt is a type conversion operation that can be stripped
    when used in a widening multiply operation.  */
@@ -2762,24 +2790,32 @@ gate_optimize_widening_mul (void)
   return flag_expensive_optimizations && optimize;
 }
 
-struct gimple_opt_pass pass_optimize_widening_mul =
+class pass_optimize_widening_mul : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "widening_mul",			/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_optimize_widening_mul,		/* gate */
-  execute_optimize_widening_mul,	/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_ssa,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_ssa
-  | TODO_verify_stmts
-  | TODO_update_ssa                     /* todo_flags_finish */
- }
-};
+public:
+  pass_optimize_widening_mul(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "widening_mul",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa | TODO_verify_stmts | TODO_update_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_optimize_widening_mul (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_optimize_widening_mul (); }
+
+}; // class pass_optimize_widening_mul
+
+gimple_opt_pass *
+make_pass_optimize_widening_mul (context &ctxt)
+{
+  return new pass_optimize_widening_mul (ctxt);
+}
diff --git a/gcc/tree-ssa-phiopt.c b/gcc/tree-ssa-phiopt.c
index 91df107..4da0024 100644
--- a/gcc/tree-ssa-phiopt.c
+++ b/gcc/tree-ssa-phiopt.c
@@ -1997,27 +1997,35 @@ gate_phiopt (void)
   return 1;
 }
 
-struct gimple_opt_pass pass_phiopt =
+class pass_phiopt : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "phiopt",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_phiopt,				/* gate */
-  tree_ssa_phiopt,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_PHIOPT,			/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_ssa
-    | TODO_verify_flow
-    | TODO_verify_stmts	 		/* todo_flags_finish */
- }
-};
+public:
+  pass_phiopt(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "phiopt",
+		      OPTGROUP_NONE,
+		      TV_TREE_PHIOPT,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa | TODO_verify_flow | TODO_verify_stmts)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_phiopt (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_ssa_phiopt (); }
+
+}; // class pass_phiopt
+
+gimple_opt_pass *
+make_pass_phiopt (context &ctxt)
+{
+  return new pass_phiopt (ctxt);
+}
 
 static bool
 gate_cselim (void)
@@ -2025,24 +2033,32 @@ gate_cselim (void)
   return flag_tree_cselim;
 }
 
-struct gimple_opt_pass pass_cselim =
+class pass_cselim : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "cselim",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_cselim,				/* gate */
-  tree_ssa_cs_elim,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_PHIOPT,			/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_ssa
-    | TODO_verify_flow
-    | TODO_verify_stmts	 		/* todo_flags_finish */
- }
-};
+public:
+  pass_cselim(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "cselim",
+		      OPTGROUP_NONE,
+		      TV_TREE_PHIOPT,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa | TODO_verify_flow | TODO_verify_stmts)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_cselim (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_ssa_cs_elim (); }
+
+}; // class pass_cselim
+
+gimple_opt_pass *
+make_pass_cselim (context &ctxt)
+{
+  return new pass_cselim (ctxt);
+}
diff --git a/gcc/tree-ssa-phiprop.c b/gcc/tree-ssa-phiprop.c
index 6555ae3..b31f7d1 100644
--- a/gcc/tree-ssa-phiprop.c
+++ b/gcc/tree-ssa-phiprop.c
@@ -404,23 +404,32 @@ gate_phiprop (void)
   return flag_tree_phiprop;
 }
 
-struct gimple_opt_pass pass_phiprop =
+class pass_phiprop : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "phiprop",			/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_phiprop,			/* gate */
-  tree_ssa_phiprop,		/* execute */
-  NULL,				/* sub */
-  NULL,				/* next */
-  0,				/* static_pass_number */
-  TV_TREE_PHIPROP,		/* tv_id */
-  PROP_cfg | PROP_ssa,		/* properties_required */
-  0,				/* properties_provided */
-  0,				/* properties_destroyed */
-  0,				/* todo_flags_start */
-  TODO_update_ssa
-  | TODO_verify_ssa		/* todo_flags_finish */
- }
-};
+public:
+  pass_phiprop(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "phiprop",
+		      OPTGROUP_NONE,
+		      TV_TREE_PHIPROP,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_update_ssa | TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_phiprop (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_ssa_phiprop (); }
+
+}; // class pass_phiprop
+
+gimple_opt_pass *
+make_pass_phiprop (context &ctxt)
+{
+  return new pass_phiprop (ctxt);
+}
diff --git a/gcc/tree-ssa-pre.c b/gcc/tree-ssa-pre.c
index 345ebcc..1ea8d60 100644
--- a/gcc/tree-ssa-pre.c
+++ b/gcc/tree-ssa-pre.c
@@ -4780,26 +4780,35 @@ gate_pre (void)
   return flag_tree_pre != 0;
 }
 
-struct gimple_opt_pass pass_pre =
+class pass_pre : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "pre",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_pre,				/* gate */
-  do_pre,				/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_PRE,				/* tv_id */
-  PROP_no_crit_edges | PROP_cfg
-    | PROP_ssa,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  TODO_rebuild_alias,			/* todo_flags_start */
-  TODO_verify_ssa			/* todo_flags_finish */
- }
-};
+public:
+  pass_pre(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "pre",
+		      OPTGROUP_NONE,
+		      TV_TREE_PRE,
+		      pass_properties(required(PROP_no_crit_edges | PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(TODO_rebuild_alias),
+				      finish(TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_pre (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return do_pre (); }
+
+}; // class pass_pre
+
+gimple_opt_pass *
+make_pass_pre (context &ctxt)
+{
+  return new pass_pre (ctxt);
+}
 
 
 /* Gate and execute functions for FRE.  */
@@ -4833,22 +4842,32 @@ gate_fre (void)
   return flag_tree_fre != 0;
 }
 
-struct gimple_opt_pass pass_fre =
+class pass_fre : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "fre",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_fre,				/* gate */
-  execute_fre,				/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_FRE,				/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_ssa			/* todo_flags_finish */
- }
-};
+public:
+  pass_fre(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "fre",
+		      OPTGROUP_NONE,
+		      TV_TREE_FRE,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_fre (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_fre (); }
+
+}; // class pass_fre
+
+gimple_opt_pass *
+make_pass_fre (context &ctxt)
+{
+  return new pass_fre (ctxt);
+}
diff --git a/gcc/tree-ssa-reassoc.c b/gcc/tree-ssa-reassoc.c
index 0089dc5..1201189 100644
--- a/gcc/tree-ssa-reassoc.c
+++ b/gcc/tree-ssa-reassoc.c
@@ -4276,24 +4276,32 @@ gate_tree_ssa_reassoc (void)
   return flag_tree_reassoc != 0;
 }
 
-struct gimple_opt_pass pass_reassoc =
+class pass_reassoc : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "reassoc",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_tree_ssa_reassoc,		/* gate */
-  execute_reassoc,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_REASSOC,			/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_ssa
-  | TODO_update_ssa_only_virtuals
-  | TODO_verify_flow			/* todo_flags_finish */
- }
-};
+public:
+  pass_reassoc(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "reassoc",
+		      OPTGROUP_NONE,
+		      TV_TREE_REASSOC,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa | TODO_update_ssa_only_virtuals | TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tree_ssa_reassoc (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_reassoc (); }
+
+}; // class pass_reassoc
+
+gimple_opt_pass *
+make_pass_reassoc (context &ctxt)
+{
+  return new pass_reassoc (ctxt);
+}
diff --git a/gcc/tree-ssa-sink.c b/gcc/tree-ssa-sink.c
index 0d9029b..1fd86c2 100644
--- a/gcc/tree-ssa-sink.c
+++ b/gcc/tree-ssa-sink.c
@@ -578,25 +578,32 @@ gate_sink (void)
   return flag_tree_sink != 0;
 }
 
-struct gimple_opt_pass pass_sink_code =
+class pass_sink_code : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "sink",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_sink,				/* gate */
-  do_sink,				/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_SINK,				/* tv_id */
-  PROP_no_crit_edges | PROP_cfg
-    | PROP_ssa,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_update_ssa
-    | TODO_verify_ssa
-    | TODO_verify_flow			/* todo_flags_finish */
- }
-};
+public:
+  pass_sink_code(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "sink",
+		      OPTGROUP_NONE,
+		      TV_TREE_SINK,
+		      pass_properties(required(PROP_no_crit_edges | PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_update_ssa | TODO_verify_ssa | TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_sink (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return do_sink (); }
+
+}; // class pass_sink_code
+
+gimple_opt_pass *
+make_pass_sink_code (context &ctxt)
+{
+  return new pass_sink_code (ctxt);
+}
diff --git a/gcc/tree-ssa-strlen.c b/gcc/tree-ssa-strlen.c
index 9c724dc..93a96a2 100644
--- a/gcc/tree-ssa-strlen.c
+++ b/gcc/tree-ssa-strlen.c
@@ -2004,22 +2004,32 @@ gate_strlen (void)
   return flag_optimize_strlen != 0;
 }
 
-struct gimple_opt_pass pass_strlen =
+class pass_strlen : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "strlen",			/* name */
-  OPTGROUP_NONE,                /* optinfo_flags */
-  gate_strlen,			/* gate */
-  tree_ssa_strlen,		/* execute */
-  NULL,				/* sub */
-  NULL,				/* next */
-  0,				/* static_pass_number */
-  TV_TREE_STRLEN,		/* tv_id */
-  PROP_cfg | PROP_ssa,		/* properties_required */
-  0,				/* properties_provided */
-  0,				/* properties_destroyed */
-  0,				/* todo_flags_start */
-  TODO_verify_ssa		/* todo_flags_finish */
- }
-};
+public:
+  pass_strlen(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "strlen",
+		      OPTGROUP_NONE,
+		      TV_TREE_STRLEN,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_strlen (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_ssa_strlen (); }
+
+}; // class pass_strlen
+
+gimple_opt_pass *
+make_pass_strlen (context &ctxt)
+{
+  return new pass_strlen (ctxt);
+}
diff --git a/gcc/tree-ssa-structalias.c b/gcc/tree-ssa-structalias.c
index 37751a7..32f7361 100644
--- a/gcc/tree-ssa-structalias.c
+++ b/gcc/tree-ssa-structalias.c
@@ -6949,48 +6949,68 @@ gate_tree_pta (void)
 /* A dummy pass to cause points-to information to be computed via
    TODO_rebuild_alias.  */
 
-struct gimple_opt_pass pass_build_alias =
-{
- {
-  GIMPLE_PASS,
-  "alias",		    /* name */
-  OPTGROUP_NONE,            /* optinfo_flags */
-  gate_tree_pta,	    /* gate */
-  NULL,                     /* execute */
-  NULL,                     /* sub */
-  NULL,                     /* next */
-  0,                        /* static_pass_number */
-  TV_NONE,                  /* tv_id */
-  PROP_cfg | PROP_ssa,      /* properties_required */
-  0,			    /* properties_provided */
-  0,                        /* properties_destroyed */
-  0,                        /* todo_flags_start */
-  TODO_rebuild_alias        /* todo_flags_finish */
- }
-};
+class pass_build_alias : public gimple_opt_pass
+{
+public:
+  pass_build_alias(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "alias",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_rebuild_alias)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tree_pta (); }
+
+  bool has_execute () { return false; }
+  unsigned int impl_execute () { return 0; }
+
+}; // class pass_build_alias
+
+gimple_opt_pass *
+make_pass_build_alias (context &ctxt)
+{
+  return new pass_build_alias (ctxt);
+}
 
 /* A dummy pass to cause points-to information to be computed via
    TODO_rebuild_alias.  */
 
-struct gimple_opt_pass pass_build_ealias =
-{
- {
-  GIMPLE_PASS,
-  "ealias",		    /* name */
-  OPTGROUP_NONE,            /* optinfo_flags */
-  gate_tree_pta,	    /* gate */
-  NULL,                     /* execute */
-  NULL,                     /* sub */
-  NULL,                     /* next */
-  0,                        /* static_pass_number */
-  TV_NONE,                  /* tv_id */
-  PROP_cfg | PROP_ssa,      /* properties_required */
-  0,			    /* properties_provided */
-  0,                        /* properties_destroyed */
-  0,                        /* todo_flags_start */
-  TODO_rebuild_alias        /* todo_flags_finish */
- }
-};
+class pass_build_ealias : public gimple_opt_pass
+{
+public:
+  pass_build_ealias(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "ealias",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_rebuild_alias)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tree_pta (); }
+
+  bool has_execute () { return false; }
+  unsigned int impl_execute () { return 0; }
+
+}; // class pass_build_ealias
+
+gimple_opt_pass *
+make_pass_build_ealias (context &ctxt)
+{
+  return new pass_build_ealias (ctxt);
+}
 
 
 /* Return true if we should execute IPA PTA.  */
@@ -7347,22 +7367,32 @@ ipa_pta_execute (void)
   return 0;
 }
 
-struct simple_ipa_opt_pass pass_ipa_pta =
-{
- {
-  SIMPLE_IPA_PASS,
-  "pta",		                /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_ipa_pta,			/* gate */
-  ipa_pta_execute,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_IPA_PTA,		        /* tv_id */
-  0,	                                /* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_update_ssa                       /* todo_flags_finish */
- }
-};
+class pass_ipa_pta : public simple_ipa_opt_pass
+{
+public:
+  pass_ipa_pta(context &ctxt)
+    : simple_ipa_opt_pass(ctxt,
+			  "pta",
+			  OPTGROUP_NONE,
+			  TV_IPA_PTA,
+			  pass_properties(required(0),
+					  provided(0),
+					  destroyed(0)),
+			  pass_todo_flags(start(0),
+					  finish(TODO_update_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_ipa_pta (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return ipa_pta_execute (); }
+
+}; // class pass_ipa_pta
+
+simple_ipa_opt_pass *
+make_pass_ipa_pta (context &ctxt)
+{
+  return new pass_ipa_pta (ctxt);
+}
diff --git a/gcc/tree-ssa-uncprop.c b/gcc/tree-ssa-uncprop.c
index c7eed9e..d9e5101 100644
--- a/gcc/tree-ssa-uncprop.c
+++ b/gcc/tree-ssa-uncprop.c
@@ -579,22 +579,32 @@ gate_uncprop (void)
   return flag_tree_dom != 0;
 }
 
-struct gimple_opt_pass pass_uncprop =
+class pass_uncprop : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "uncprop",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_uncprop,				/* gate */
-  tree_ssa_uncprop,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_SSA_UNCPROP,			/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_ssa	                /* todo_flags_finish */
- }
-};
+public:
+  pass_uncprop(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "uncprop",
+		      OPTGROUP_NONE,
+		      TV_TREE_SSA_UNCPROP,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_uncprop (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_ssa_uncprop (); }
+
+}; // class pass_uncprop
+
+gimple_opt_pass *
+make_pass_uncprop (context &ctxt)
+{
+  return new pass_uncprop (ctxt);
+}
diff --git a/gcc/tree-ssa-uninit.c b/gcc/tree-ssa-uninit.c
index e8f3ff7..cadfc7f 100644
--- a/gcc/tree-ssa-uninit.c
+++ b/gcc/tree-ssa-uninit.c
@@ -2024,22 +2024,34 @@ gate_warn_uninitialized (void)
   return warn_uninitialized != 0;
 }
 
-struct gimple_opt_pass pass_late_warn_uninitialized =
+class pass_late_warn_uninitialized : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "uninit",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_warn_uninitialized,		/* gate */
-  execute_late_warn_uninitialized,	/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,     	        		/* tv_id */
-  PROP_ssa,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_late_warn_uninitialized(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "uninit",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_warn_uninitialized (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return execute_late_warn_uninitialized ();
+  }
+
+}; // class pass_late_warn_uninitialized
+
+gimple_opt_pass *
+make_pass_late_warn_uninitialized (context &ctxt)
+{
+  return new pass_late_warn_uninitialized (ctxt);
+}
diff --git a/gcc/tree-ssa.c b/gcc/tree-ssa.c
index b0619fa..9f019f3 100644
--- a/gcc/tree-ssa.c
+++ b/gcc/tree-ssa.c
@@ -1124,25 +1124,35 @@ execute_init_datastructures (void)
   return 0;
 }
 
-struct gimple_opt_pass pass_init_datastructures =
+class pass_init_datastructures : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "*init_datastructures",		/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  execute_init_datastructures,		/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_cfg,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0					/* todo_flags_finish */
- }
-};
+public:
+  pass_init_datastructures(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "*init_datastructures",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_init_datastructures (); }
+
+}; // class pass_init_datastructures
+
+gimple_opt_pass *
+make_pass_init_datastructures (context &ctxt)
+{
+  return new pass_init_datastructures (ctxt);
+}
 
 /* Deallocate memory associated with SSA data structures for FNDECL.  */
 
@@ -1734,25 +1744,37 @@ gate_warn_uninitialized (void)
   return warn_uninitialized != 0;
 }
 
-struct gimple_opt_pass pass_early_warn_uninitialized =
+class pass_early_warn_uninitialized : public gimple_opt_pass
+{
+public:
+  pass_early_warn_uninitialized(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "*early_warn_uninitialized",
+		      OPTGROUP_NONE,
+		      TV_TREE_UNINIT,
+		      pass_properties(required(PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_warn_uninitialized (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return execute_early_warn_uninitialized ();
+  }
+
+}; // class pass_early_warn_uninitialized
+
+gimple_opt_pass *
+make_pass_early_warn_uninitialized (context &ctxt)
 {
- {
-  GIMPLE_PASS,
-  "*early_warn_uninitialized",		/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_warn_uninitialized,		/* gate */
-  execute_early_warn_uninitialized,	/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_UNINIT,			/* tv_id */
-  PROP_ssa,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+  return new pass_early_warn_uninitialized (ctxt);
+}
 
 
 /* If necessary, rewrite the base of the reference tree *TP from
@@ -2165,22 +2187,32 @@ execute_update_addresses_taken (void)
   timevar_pop (TV_ADDRESS_TAKEN);
 }
 
-struct gimple_opt_pass pass_update_address_taken =
+class pass_update_address_taken : public gimple_opt_pass
+{
+public:
+  pass_update_address_taken(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "addressables",
+		      OPTGROUP_NONE,
+		      TV_ADDRESS_TAKEN,
+		      pass_properties(required(PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_update_address_taken)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return false; }
+  unsigned int impl_execute () { return 0; }
+
+}; // class pass_update_address_taken
+
+gimple_opt_pass *
+make_pass_update_address_taken (context &ctxt)
 {
- {
-  GIMPLE_PASS,
-  "addressables",			/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  NULL,					/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_ADDRESS_TAKEN,			/* tv_id */
-  PROP_ssa,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_update_address_taken             /* todo_flags_finish */
- }
-};
+  return new pass_update_address_taken (ctxt);
+}
